diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..e767f23
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,12 @@
+*.o
+*.lo
+*.so
+*.a
+*.orig
+*.rej
+*.log
+
+Makefile
+config.*
+configure
+
diff --git a/mod_openzap/mod_openzap.c b/mod_openzap/mod_openzap.c
index d28a754..b993a0a 100644
--- a/mod_openzap/mod_openzap.c
+++ b/mod_openzap/mod_openzap.c
@@ -673,6 +673,17 @@ static switch_status_t channel_write_frame(switch_core_session_t *session, switc
 
 }
 
+#define zap_state_wait(x) 								\
+	do {										\
+		int __safety = 100;							\
+		while(__safety-- && zap_test_flag(x, ZAP_CHANNEL_STATE_CHANGE)) {	\
+			zap_sleep(10);							\
+		}									\
+		if(!__safety) {								\
+			zap_log(ZAP_LOG_CRIT, "State change not completed\n");		\
+		}									\
+	} while(0);
+
 static switch_status_t channel_receive_message_b(switch_core_session_t *session, switch_core_session_message_t *msg)
 {
 	switch_channel_t *channel;
@@ -691,6 +702,7 @@ static switch_status_t channel_receive_message_b(switch_core_session_t *session,
 				zap_set_flag_locked(tech_pvt->zchan, ZAP_CHANNEL_PROGRESS);
 			} else {
 				zap_set_state_locked(tech_pvt->zchan, ZAP_CHANNEL_STATE_PROGRESS);
+				zap_state_wait(tech_pvt->zchan);
 			}
 		}
 		break;
@@ -701,6 +713,7 @@ static switch_status_t channel_receive_message_b(switch_core_session_t *session,
 				zap_set_flag_locked(tech_pvt->zchan, ZAP_CHANNEL_MEDIA);
 			} else {
 				zap_set_state_locked(tech_pvt->zchan, ZAP_CHANNEL_STATE_PROGRESS_MEDIA);
+				zap_state_wait(tech_pvt->zchan);
 			}
 		}
 		break;
@@ -710,6 +723,7 @@ static switch_status_t channel_receive_message_b(switch_core_session_t *session,
 				zap_set_flag_locked(tech_pvt->zchan, ZAP_CHANNEL_ANSWERED);
 			} else {
 				zap_set_state_locked(tech_pvt->zchan, ZAP_CHANNEL_STATE_UP);
+				zap_state_wait(tech_pvt->zchan);
 			}
 		}
 		break;
diff --git a/src/include/zap_isdn.h b/src/include/zap_isdn.h
index 91f35b2..e18a51a 100644
--- a/src/include/zap_isdn.h
+++ b/src/include/zap_isdn.h
@@ -53,10 +53,11 @@ struct zap_isdn_data {
 	struct zap_sigmsg sigmsg;
 	zio_signal_cb_t sig_cb;
 	uint32_t flags;
+	int32_t mode;
+	zap_isdn_opts_t opts;
 	zap_caller_data_t *outbound_crv[32768];
 	zap_channel_t *channels_local_crv[32768];
 	zap_channel_t *channels_remote_crv[32768];
-	zap_isdn_opts_t opts;
 };
 
 
diff --git a/src/include/zap_types.h b/src/include/zap_types.h
index be43d0d..7c092e7 100644
--- a/src/include/zap_types.h
+++ b/src/include/zap_types.h
@@ -117,11 +117,12 @@ typedef enum {
 	ZAP_TRUNK_T1,
 	ZAP_TRUNK_J1,
 	ZAP_TRUNK_BRI,
+	ZAP_TRUNK_BRI_PTMP,
 	ZAP_TRUNK_FXO,
 	ZAP_TRUNK_FXS,
 	ZAP_TRUNK_NONE
 } zap_trunk_type_t;
-#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "FXO", "FXS", "NONE"
+#define TRUNK_STRINGS "E1", "T1", "J1", "BRI", "BRI_PTMP", "FXO", "FXS", "NONE"
 ZAP_STR2ENUM_P(zap_str2zap_trunk_type, zap_trunk_type2str, zap_trunk_type_t)
 
 typedef enum {
diff --git a/src/isdn/5ESSStateTE.c b/src/isdn/5ESSStateTE.c
index 05a11b0..a9654ce 100644
--- a/src/isdn/5ESSStateTE.c
+++ b/src/isdn/5ESSStateTE.c
@@ -240,7 +240,7 @@ L3INT ATT5ESSProc0x0fTE(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT iFrom)
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+        ret = Q931Tx32Data(pTrunk,0,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -283,7 +283,7 @@ L3INT ATT5ESSProc0x07TE(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT iFrom)
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+        ret = Q931Tx32Data(pTrunk,0,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
diff --git a/src/isdn/5ESSmes.c b/src/isdn/5ESSmes.c
index 6a6f468..da47f7a 100644
--- a/src/isdn/5ESSmes.c
+++ b/src/isdn/5ESSmes.c
@@ -158,12 +158,7 @@ L3INT ATT5ESSPmes_Setup(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *IBuf, L3INT I
     L3INT Octet = 0;
 
     /* Q931 Message Header */
-
-    OBuf[Octet++]    = pMes->ProtDisc;          /* Protocol discriminator           */
-    OBuf[Octet++]    = 2;                       /* length is 2 octets               */
-    OBuf[Octet++]    = (L3UCHAR)(pMes->CRV>>8) | (pMes->CRVFlag << 7);    /* msb    */
-    OBuf[Octet++]    = (L3UCHAR)(pMes->CRV);    /* lsb                              */
-    OBuf[Octet++]    = pMes->MesType;           /* message header                   */
+	Q931MesgHeader(pTrunk, pMes, OBuf, *OSize, &Octet);
     
     /* Sending Complete                */
     if(Q931IsIEPresent(pMes->SendComplete))
diff --git a/src/isdn/DMSStateTE.c b/src/isdn/DMSStateTE.c
index 5658415..8c435fa 100644
--- a/src/isdn/DMSStateTE.c
+++ b/src/isdn/DMSStateTE.c
@@ -237,7 +237,7 @@ L3INT DMSProc0x0fTE(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT iFrom)
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+        ret = Q931Tx32Data(pTrunk,0,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
@@ -279,7 +279,7 @@ L3INT DMSProc0x07TE(Q931_TrunkInfo_t *pTrunk, L3UCHAR * buf, L3INT iFrom)
 	if(iFrom == 4)
 	{
 		/* TODO Add proc here*/
-        ret = Q931Tx32(pTrunk,buf,pMes->Size);
+        ret = Q931Tx32Data(pTrunk,0,buf,pMes->Size);
 	}
 	else if (iFrom ==2)
 	{
diff --git a/src/isdn/DMSmes.c b/src/isdn/DMSmes.c
index 57aeddf..b32664b 100644
--- a/src/isdn/DMSmes.c
+++ b/src/isdn/DMSmes.c
@@ -155,12 +155,7 @@ L3INT DMSPmes_Setup(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *IBuf, L3INT ISize
 	L3INT Octet = 0;
 
 	/* Q931 Message Header */
-
-	OBuf[Octet++]	= pMes->ProtDisc;		/* Protocol discriminator		*/
-	OBuf[Octet++]	= 2;					/* length is 2 octets			*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV>>8) | (pMes->CRVFlag << 7);	/* msb						*/
-	OBuf[Octet++]	= (L3UCHAR)(pMes->CRV);	/* lsb							*/
-	OBuf[Octet++]	= pMes->MesType;		/* message header				*/
+	Q931MesgHeader(pTrunk, pMes, OBuf, *OSize, &Octet);
 	
 	/* Sending Complete				*/
 	if(Q931IsIEPresent(pMes->SendComplete))
diff --git a/src/isdn/Q921.c b/src/isdn/Q921.c
index 2dad5cf..a682c23 100644
--- a/src/isdn/Q921.c
+++ b/src/isdn/Q921.c
@@ -37,12 +37,323 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 *****************************************************************************/
-#include "Q921.h"
+
+/****************************************************************************
+ * Changes:
+ *
+ * - June-August 2008: Stefan Knoblich <s.knoblich@axsentis.de>:
+ *     Add PTMP TEI management (NT + TE mode)
+ *     Add timers
+ *     Add retransmit counters
+ *     Add logging
+ *     Various cleanups
+ *     Queues, retransmission of I frames
+ *     PTMP NT mode
+ *
+ *
+ * TODO:
+ *
+ * - Cleanup queueing, test retransmission
+ *
+ * - Q921Start() /-Stop() TEI acquire + release
+ *   (move everything related into these functions)
+ *
+ * - Q.921 '97 Appendix I (and maybe III, IV)
+ *
+ * - More complete Appendix II
+ *
+ * - Test PTP mode
+ *
+ * - PTMP NT mode (in progress)
+ *
+ * - NT mode TEI management: (ab)use T202 for TEI Check Request retransmission
+ *
+ * - General cleanup (move all non-public declarations into private header file)
+ *
+ * - Statistics, per-Frame type debug message filter
+ *
+ ****************************************************************************/
+
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
+#include <stdarg.h>
+
+#include "Q921.h"
+#include "Q921priv.h"
 #include "mfifo.h"
 
-int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf);
+
+/******************************************************************************************************
+ * Actual code below this line
+ ******************************************************************************************************/
+
+
+/**
+ * Q921StateNames
+ * \brief	Static array of state name / value mappings
+ */
+static struct Q921StateName {
+	Q921State_t value;
+	const char *name;
+} Q921StateNames[10] = {
+	{ Q921_STATE_STOPPED, "Stopped" },
+	{ Q921_STATE_TEI_UNASSIGNED, "TEI Unassigned" },
+	{ Q921_STATE_TEI_AWAITING, "TEI Awaiting Assignment" },
+	{ Q921_STATE_TEI_ESTABLISH, "TEI Awaiting Establishment" },
+	{ Q921_STATE_TEI_ASSIGNED, "TEI Assigned" },
+	{ Q921_STATE_AWAITING_ESTABLISHMENT, "Awaiting Establishment" },
+	{ Q921_STATE_AWAITING_RELEASE, "Awaiting Release" },
+	{ Q921_STATE_MULTIPLE_FRAME_ESTABLISHED, "Multiple Frame Mode Established" },
+	{ Q921_STATE_TIMER_RECOVERY, "Timer Recovery" },
+	{ 0, 0 }
+};
+
+/**
+ * Q921State2Name
+ * \brief	Convert state value to name
+ * \param[in]	state	the state value
+ * \return	the state name or "Unknown"
+ *
+ * \author	Stefan Knoblich
+ */
+static const char *Q921State2Name(Q921State_t state)
+{
+	struct Q921StateName *p = Q921StateNames;
+
+	while(p->name) {
+		if(p->value == state)
+			return p->name;
+		p++;
+	}
+
+	return "Unknown";
+}
+
+
+/**
+ * Q921SendEnquiry
+ */
+static int Q921SendEnquiry(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* send enquiry: begin */
+	if(Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+
+		Q921SendRNR(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+	}
+	else {
+		Q921SendRR(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+	}
+
+	/* clear acknowledge pending */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+	/* "Start" T200 */
+	Q921T200TimerReset(trunk, tei);
+
+	/* send enquiry: end */
+	return 1;
+}
+
+/**
+ * Q921SendEnquiryResponse
+ */
+static int Q921SendEnquiryResponse(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* send enquiry: begin */
+	if(Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY)) {
+
+		Q921SendRNR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+	}
+	else {
+		Q921SendRR(trunk, trunk->sapi, Q921_RESPONSE(trunk), tei, 1);
+
+		/* clear acknowledge pending */
+		Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+	}
+	/* send enquiry: end */
+	return 1;
+}
+
+/**
+ * Q921ResetExceptionConditions
+ * \brief	Reset Q.921 Exception conditions procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \todo	Do something
+ */
+static void Q921ResetExceptionConditions(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* Clear peer receiver busy */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_PEER_RECV_BUSY);
+
+	/* Clear reject exception */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_REJECT);
+
+	/* Clear own receiver busy */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_RECV_BUSY);
+
+	/* Clear acknowledge pending */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+	return;
+}
+
+/**
+ * Q921EstablishDataLink
+ * \brief	Q.921 Establish data link procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \return	always 1 (success)
+ */
+static int Q921EstablishDataLink(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* reset exception conditions */
+	Q921ResetExceptionConditions(trunk, tei);
+
+	/* RC = 0 */
+	link->N200 = 0;
+
+	/* Send SABME */
+	Q921SendSABME(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 1);
+
+	/* Restart T200, stop T203 */
+	Q921T200TimerReset(trunk, tei);
+	Q921T203TimerStop(trunk, tei);
+
+	return 1;
+}
+
+/**
+ * Q921NrErrorRecovery
+ * \brief	NR(R) Error recovery procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \return	always 1 (success)
+ */
+static int Q921NrErrorRecovery(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	/* MDL Error indication (J) */
+
+	/* Establish datalink */
+	Q921EstablishDataLink(trunk, tei);
+
+	/* Clear L3 initiated */
+	Q921_CLEAR_FLAG(link, Q921_FLAG_L3_INITIATED);
+
+	return 1;
+}
+
+
+/**
+ * Q921InvokeRetransmission
+ * \brief	I Frame retransmission procedure
+ * \param	trunk	Q.921 data structure
+ * \param	tei	TEI
+ * \param	nr	N(R) for retransmission
+ * \return	always 1 (success)
+ */
+static int Q921InvokeRetransmission(L2TRUNK trunk, L2UCHAR tei, L2UCHAR nr)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+	L2UCHAR *mes;
+	L2INT qpos, qnum, size = 0;
+
+	qnum = MFIFOGetMesCount(link->IFrameResendQueue);
+	qpos = qnum - 1;
+
+	/*
+	 * slightly different than what is shown in the spec
+	 * (Q.921 '97 Annex B, Figure B.9, page 104)
+	 * 
+	 * what the above mentioned figure probably means is:
+	 * "as long as V(S) != N(R), move the pointer marking
+	 *  the first frame to start resending at to the previous
+	 *  frame"
+	 *
+	 * if we actually implemented it as shown in the figure, we'd be
+	 * resending frames in the wrong order (moving backwards in time)
+	 * meaning we'd have to add an incoming queue to reorder the frames
+	 *
+	 */
+	/*
+	 * TODO: There's a "traditional" off-by-one error hidden in the original
+	 *       mfifo implementation + it's late, i'm tired and being lazy,
+	 *       so i'll probably have added another one :P
+	 *
+	 *       wow, the first while loop sucks and can be removed
+	 */
+	while(link->vs != nr && qpos > 0) {	/* ???? */
+		/* V(S) = V(S) - 1 */
+		Q921_DEC_COUNTER(link->vs);	/* huh? backwards? */
+
+		/* next frame in queue (backtrack along I queue) ??? */
+		qpos--;
+	}
+
+	/*
+	 * being lazy and trying to avoid mod 128 math this way...
+	 */
+	if(link->vs != nr && !qpos) {
+		/* fatal, we don't have enough history to resend all missing frames */
+		/* TODO: how to handle this? */
+	}
+
+	/*
+	 * resend frames in correct order (oldest missing frame first,
+	 * contrary to what the spec figure shows)
+	 */
+	while(qpos < qnum) {
+		/* Grab frame's buffer ptr and size from queue */
+		mes = MFIFOGetMesPtrOffset(link->IFrameResendQueue, &size, qpos);
+		if(mes) {
+			/* requeue frame (TODO: check queue full condition) */
+			MFIFOWriteMes(link->IFrameQueue, mes, size);
+
+			/* set I frame queued */
+		}
+
+		qpos++;
+	}
+
+	return 1;
+}
+
+
+static int Q921AcknowledgePending(L2TRUNK trunk, L2UCHAR tei)
+{
+	struct Q921_Link *link = Q921_LINK_CONTEXT(trunk, tei);
+
+	switch(link->state) {
+	case Q921_STATE_MULTIPLE_FRAME_ESTABLISHED:
+	case Q921_STATE_TIMER_RECOVERY:
+		if(Q921_CHECK_FLAG(link, Q921_FLAG_ACK_PENDING)) {
+			/* clear acknowledge pending */
+			Q921_CLEAR_FLAG(link, Q921_FLAG_ACK_PENDING);
+
+			/* send RR */
+			Q921SendRR(trunk, trunk->sapi, Q921_COMMAND(trunk), tei, 0);
+
+			return 1;
+		}
+		break;
+
+	default:
+		break;
+	}
+
+	return 0;
+}
 
 /*****************************************************************************
 
@@ -52,47 +363,461 @@ int Q921SendRR(L2TRUNK trunk, int Sapi, int cr, int Tei, int pf);
                 function MUST be called before you call any other functions.
 
 *****************************************************************************/
-void Q921_InitTrunk(L2TRUNK trunk,
+int Q921_InitTrunk(L2TRUNK trunk,
 					L2UCHAR sapi,
 					L2UCHAR tei,
 					Q921NetUser_t NetUser,
+					Q921NetType_t NetType,
 					L2INT hsize,
-					Q921TxCB_t cb21,
-					Q921TxCB_t cb23,
+					Q921Tx21CB_t cb21,
+					Q921Tx23CB_t cb23,
 					void *priv21,
 					void *priv23)
 {
-	if (trunk->initialized != INITIALIZED_MAGIC) {
-		MFIFOCreate(trunk->HDLCInQueue, Q921MAXHDLCSPACE, 10);
-		trunk->initialized = INITIALIZED_MAGIC;
-	}
-	trunk->va = 0;
-	trunk->vs = 0;	
-	trunk->vr = 0;
-	trunk->state = 0;
+	int numlinks = 0;
+
 	trunk->sapi = sapi;
 	trunk->tei = tei;
 	trunk->NetUser = NetUser;
+	trunk->NetType = NetType;
 	trunk->Q921Tx21Proc = cb21;
 	trunk->Q921Tx23Proc = cb23;
 	trunk->PrivateData21 = priv21;
 	trunk->PrivateData23 = priv23;
 	trunk->Q921HeaderSpace = hsize;
-	trunk->T200 = 0;
-	trunk->T203 = 0;
-	trunk->T200Timeout = 1000;
-	trunk->T203Timeout = 10000;
+
+	numlinks = Q921_IS_PTMP_NT(trunk) ? Q921_TEI_MAX : 1;
+
+	if (trunk->initialized != INITIALIZED_MAGIC) {
+		MFIFOCreate(trunk->HDLCInQueue, Q921MAXHDLCSPACE, 10);
+
+		/*
+		 * Allocate space for per-link context(s)
+		 */
+		trunk->context = malloc(numlinks * sizeof(struct Q921_Link));
+		if(!trunk->context)
+			return -1;
+
+		trunk->initialized = INITIALIZED_MAGIC;
+	}
+
+	/* timeout default values */
+	trunk->T200Timeout = 1000;	/*   1 second  */
+	trunk->T203Timeout = 10000;	/*  10 seconds */
+	trunk->T202Timeout = 2000;	/*   2 seconds */
+	trunk->T201Timeout = 200000;	/* 200 seconds */
+	trunk->TM01Timeout = 10000;	/*  10 seconds */
+
+	/* octet / retransmit counter default limits */
+	trunk->N200Limit   = 3;		/*   3 retransmits */
+	trunk->N201Limit   = 260;	/* 260 octets      */
+	trunk->N202Limit   = 3;		/*   3 retransmits */
+	trunk->k           = 7;		/*   7 outstanding ACKs */
+
+	/* reset counters, timers, etc. */
+	trunk->T202 = 0;
+	trunk->N202 = 0;
+
+	/* Reset per-link contexts */
+	memset(trunk->context, 0, numlinks * sizeof(struct Q921_Link));
+
+	/* clear tei map */
+	memset(trunk->tei_map, 0, Q921_TEI_MAX + 1);
+
+	if(Q921_IS_PTMP(trunk)) {
+		/*
+		 * We're either the Network side (NT, TEI = 0)
+		 * or user-side equipment (TE) which will get it's TEI via
+		 * dynamic assignment
+		 */
+		trunk->tei = 0;
+	}
+
+	return 0;
 }
 
-int Q921Tx21Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
+
+/**
+ * Q921Tx21Proc
+ * \brief	Submit frame to layer 1 (for sending)
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ */
+static int Q921Tx21Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
 {
+	Q921LogMesg(trunk, Q921_LOG_DEBUG, 0, Msg, size, "Sending frame");
+
 	return trunk->Q921Tx21Proc(trunk->PrivateData21, Msg, size);
 }
 
-int Q921Tx23Proc(L2TRUNK trunk, L2UCHAR *Msg, L2INT size)
+
+/**
+ * Q921Tx23Proc
+ * \brief	Submit frame to layer 3
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \return	> 0 on success; <= 0 on error
+ */
+static int Q921Tx23Proc(L2TRUNK trunk, Q921DLMsg_t ind, L2UCHAR tei, L2UCHAR *Msg, L2INT size)
+{
+	return trunk->Q921Tx23Proc(trunk->PrivateData23, ind, tei, Msg, size);
+}
+
+
+/**
+ * Q921LogProc
+ * \brief	Used for logging, converts to string and submits to higher level log function via callback
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	level	Q921 Loglevel
+ * \param[in]	fmt	format of logmessage
+ * \return	>= 0 on success, < 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921Log(L2TRUNK trunk, Q921LogLevel_t level, const char *fmt, ...)
+{
+	char  buf[Q921_LOGBUFSIZE];
+	L2INT len;
+	va_list ap;
+
+	if(!trunk->Q921LogProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, sizeof(buf)-1, fmt, ap);
+	if(len <= 0) {
+		/* TODO: error handling */
+		return -1;
+	}
+	if(len >= sizeof(buf))
+		len = sizeof(buf) - 1;
+
+	buf[len] = '\0';
+
+	va_end(ap);
+
+	return trunk->Q921LogProc(trunk->PrivateDataLog, level, buf, len);
+}
+
+
+static int print_hex(char *buf, int bsize, const unsigned char *in, const int len)
 {
-	return trunk->Q921Tx23Proc(trunk->PrivateData23, Msg, size);
+	static const char hex[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
+	int offset = 0;
+	int pos    = 0;
+	int nr     = 0;
+
+	buf[pos++] = '[';
+	bsize -= 3;
+
+	while((bsize - pos) > 0 && offset < len) {
+		buf[pos++] = hex[(in[offset] & 0xF0) >> 4];
+		buf[pos++] = hex[(in[offset++]   & 0x0F)];
+
+		if(++nr == 32 && offset < len && (bsize - pos) > 3) {
+			nr = 0;
+			buf[pos++] = ']';
+			buf[pos++] = '\n';
+			buf[pos++] = '[';
+		}
+		else if(offset < len) {
+			buf[pos++] = ' ';
+		}
+	}
+
+	buf[pos++] = ']';
+	buf[pos++] = '\n';
+	buf[pos]   = '\0';
 
+	return pos;
+}
+
+#define APPEND_MSG(buf, off, lef, fmt, ...) 			\
+	len = snprintf(buf + off, lef, fmt, ##__VA_ARGS__);	\
+	if(len > 0) { 						\
+		off += len;					\
+		lef -= len;					\
+	} else {						\
+		goto out;					\
+	}
+
+/**
+ * Q921LogProcMesg
+ * \brief	Used for logging, converts to string and submits to higher level log function via callback
+ * \param[in]	trunk	Pointer to trunk struct
+ * \param[in]	level	Q921 Loglevel
+ * \param[in]	received	direction of the message (received = 1, sending = 0)
+ * \param[in]	mes	pointer to message buffer
+ * \param[in]	size	size of message
+ * \param[in]	fmt	format of logmessage
+ * \return	>= 0 on success, < 0 on error
+ *
+ * \author	Stefan Knoblich
+ */
+static int Q921LogMesg(L2TRUNK trunk, Q921LogLevel_t level, L2UCHAR received, L2UCHAR *mes, L2INT size, const char *fmt, ...)
+{
+	char  buf[Q921_LOGBUFSIZE];
+	L2INT len, left;
+	va_list ap;
+
+	if(!trunk->Q921LogProc)
+		return 0;
+
+	if(trunk->loglevel < level)
+		return 0;
+
+	if(!mes)
+		return 0;
+
+
+	left = sizeof(buf) - 1;
+
+	va_start(ap, fmt);
+
+	len = vsnprintf(buf, left, fmt, ap);
+	if(len > 0)
+		left -= len;
+	else {
+		/* TODO: error handling */
+		return -1;
+	}
+
+	va_end(ap);
+
+	if(trunk->loglevel == Q921_LOG_DEBUG) {
+		char pbuf[1024];
+		L2INT pleft, poffset;
+		L2UCHAR sapi, tei, cr;
+		L2UCHAR *pmes = mes + trunk->Q921HeaderSpace;
+		struct Q921_Link *link;
+
+		pleft   = sizeof(pbuf);
+		poffset = 0;
+
+		/*
+		 * Decode packet
+		 */
+		sapi = (pmes[0] & 0xfc) >> 2;
+		cr   = (pmes[0] & 0x02) >> 1;
+		tei  = (pmes[1] & 0xfe) >> 1;
+		link  = Q921_LINK_CONTEXT(trunk, tei);
+
+		/* make cr actually useful */
+		cr   = (received) ? Q921_IS_COMMAND(trunk, cr) : Q921_IS_RESPONSE(trunk, cr);
+
+		/* filter */
+		if((pmes[2] & 0x01) == 0x00) {
+ 			;
+		}
+		else if((pmes[2] & 0x03) == 0x01) {
+			; //return 0;
+		}
+		else if((pmes[2] & 0x03) == 0x03) {
+			;
+		}
+
+		APPEND_MSG(pbuf, poffset, pleft, "\n----------------- Q.921 Packet [%s%s] ---------------\n", received ? "Incoming" : "Outgoing",
+						(tei == link->tei || tei == Q921_TEI_BCAST) ? "" : ", Ignored" );
+
+		/* common header */
+		APPEND_MSG(pbuf, poffset, pleft, "    SAPI: %u, TEI: %u, C/R: %s (%d)\n\n", sapi, tei, (cr) ? "Command" : "Response", (mes[0] & 0x02) >> 1 );
+
+		/*
+		 * message specific
+		 */
+		if((pmes[2] & 0x01) == 0x00) {
+			/*
+			 * I frame
+			 */
+			L2UCHAR pf = pmes[3] & 0x01;	/* poll / final flag */
+			L2UCHAR nr = pmes[3] >> 1;	/* receive sequence number */
+			L2UCHAR ns = pmes[2] >> 1;	/* send sequence number */
+
+			APPEND_MSG(pbuf, poffset, pleft, "    Type: I Frame\n          P/F: %d, N(S): %d, N(R): %d  [V(A): %d, V(R): %d, V(S): %d]\n", pf, ns, nr,
+														link->va, link->vr, link->vs);
+
+			/* Dump content of I Frames for foreign TEIs */
+			if(tei != link->tei) {
+				APPEND_MSG(pbuf, poffset, pleft, "    CONTENT:\n");
+
+				len = print_hex(pbuf + poffset, pleft, &pmes[4], size - (trunk->Q921HeaderSpace + 4));
+				poffset += len;
+				pleft   -= len;
+			}
+		}
+		else if((pmes[2] & 0x03) == 0x01) {
+			/*
+			 * S frame
+			 */
+			L2UCHAR sv = (pmes[2] & 0x0c) >> 2;	/* supervisory format id */
+			L2UCHAR pf =  pmes[3] & 0x01;		/* poll / final flag */
+			L2UCHAR nr =  pmes[3] >> 1;		/* receive sequence number */
+			const char *type;
+
+			switch(sv) {
+			case 0x00:	/* RR : Receive Ready */
+				type = "RR (Receive Ready)";
+				break;
+
+			case 0x02:	/* RNR : Receive Not Ready */
+				type = "RNR (Receiver Not Ready)";
+				break;
+
+			case 0x04:	/* REJ : Reject */
+				type = "REJ (Reject)";
+				break;
+
+			default:	/* Invalid / Unknown */
+				type = "Unknown";
+				break;
+			}
+
+			APPEND_MSG(pbuf, poffset, pleft, "    Type: S Frame, SV: %s\n          P/F: %d, N(R): %d  [V(A): %d, V(R): %d, V(S): %d]\n", type, pf, nr,
+														link->va, link->vr, link->vs);
+		}
+		else if((pmes[2] & 0x03) == 0x03) {
+			/*
+			 * U frame
+			 */
+			L2UCHAR m  = (pmes[2] & 0xe0) >> 3 | (pmes[2] & 0x0c) >> 2;	/* modifier function id */
+			L2UCHAR pf = (pmes[2] & 0x10) >> 4;				/* poll / final flag */
+			const char *type;
+
+			switch(m) {
+			case 0x00:
+				type = "UI (Unnumbered Information)";
+				break;
+
+			case 0x03:
+				type = "DM (Disconnected Mode)";
+				break;
+
+			case 0x08:
+				type = "DISC (Disconnect)";
+				break;
+
+			case 0x0c:
+				type = "UA (Unnumbered Acknowledgement)";
+				break;
+
+			case 0x0f:
+				type = "SABME";
+				break;
+
+			case 0x11:
+				type = "FRMR (Frame Reject)";
+				break;
+
+			case 0x17:
+				type = "XID (Exchange Identification)";
+				break;
+
+			default:
+				type = "Unknown";
+			}
+
+
+			APPEND_MSG(pbuf, poffset, pleft, "    Type: U Frame (%s)\n          P/F: %d\n", type, pf);
+
+			if(m == 0x00) {
+				switch(pmes[3]) {
+				case Q921_LAYER_ENT_ID_TEI:
+					type = "TEI Mgmt";
+					break;
+
+				case Q921_LAYER_ENT_ID_Q931:
+					type = "Q.931";
+					break;
+
+				default:
+					type = "Unknown";
+				}
+
+				if(pmes[3] == Q921_LAYER_ENT_ID_TEI) {
+					const char *command = "";
+
+					switch(pmes[6]) {
+					case Q921_TEI_ID_REQUEST:
+						command = "Request";
+						break;
+					case Q921_TEI_ID_VERIFY:
+						command = "Verify";
+						break;
+					case Q921_TEI_ID_CHECKREQ:
+						command = "Check req";
+						break;
+					case Q921_TEI_ID_CHECKRESP:
+						command = "Check resp";
+						break;
+					case Q921_TEI_ID_REMOVE:
+						command = "Remove";
+						break;
+					case Q921_TEI_ID_ASSIGNED:
+						command = "Assign";
+						break;
+					case Q921_TEI_ID_DENIED:
+						command = "Denied";
+						break;
+					}
+					APPEND_MSG(pbuf, poffset, pleft, "    ENT ID: %d (%s), COMMAND: %d (%s), RI: %#x, AI: %d\n",
+							 pmes[3], type, pmes[6], command, (int)((pmes[4] << 8) | pmes[5]), pmes[7] >> 1);
+				}
+				else {
+					APPEND_MSG(pbuf, poffset, pleft, "    ENT ID: %d (%s), MESSAGE CONTENT:\n", pmes[3], type);
+
+					len = print_hex(pbuf + poffset, pleft, &pmes[3], size - (trunk->Q921HeaderSpace + 3));
+					poffset += len;
+					pleft   -= len;
+				}
+			}
+		}	
+		else {
+			/*
+			 * Unknown
+			 */
+			strncat(pbuf + poffset, "  -- unknown frame type --\n", pleft);
+
+			len = (sizeof(pbuf) - poffset) - strlen(pbuf + poffset);
+			if(len > 0) {
+				poffset += len;
+				pleft   -= len;
+			} else
+				goto out;
+		}
+
+		APPEND_MSG(pbuf, poffset, pleft, "\n    Q.921 state: \"%s\" (%d) [flags: %c%c%c%c]\n", Q921State2Name(link->state), link->state,
+											Q921_CHECK_FLAG(link, Q921_FLAG_ACK_PENDING) ? 'A' : '-',
+											Q921_CHECK_FLAG(link, Q921_FLAG_REJECT) ? 'R' : '-',
+											Q921_CHECK_FLAG(link, Q921_FLAG_PEER_RECV_BUSY) ? 'P' : '-',
+											Q921_CHECK_FLAG(link, Q921_FLAG_RECV_BUSY) ? 'B' : '-');
+
+		strncat(pbuf + poffset, "----------------------------------------------\n\n", pleft);
+
+		len = (sizeof(pbuf) - poffset) - strlen(pbuf + poffset);
+		if(len > 0) {
+			poffset += len;
+			pleft   -= len;
+		} else
+			goto out;
+
+
+		/* concat buffers together */
+		len = strlen(pbuf);
+		if(len <= left)
+			strncat(buf, pbuf, left);
+		else
+			strncat(buf, "-- packet truncated --\n", left);
+	}
+
+out:
+	return trunk->Q921LogProc(trunk->PrivateDataLog, level, buf, strlen(buf));
 }
 
 /*****************************************************************************
